## crac-criu 4.1.1

=== Makefile ===
__nmk_dir=$(CURDIR)/scripts/nmk/scripts/
export __nmk_dir

#
# No need to try to remake our Makefiles
Makefile: ;
Makefile.%: ;
scripts/%.mak: ;
$(__nmk_dir)%.mk: ;

#
# Import the build engine
include $(__nmk_dir)include.mk
include $(__nmk_dir)macro.mk

ifeq ($(origin HOSTCFLAGS), undefined)
        HOSTCFLAGS := $(CFLAGS) $(USERCFLAGS)
endif

#
# Supported Architectures
ifneq ($(filter-out x86 arm aarch64 ppc64 s390 mips loongarch64 riscv64,$(ARCH)),)
        $(error "The architecture $(ARCH) isn't supported")
endif

# The PowerPC 64 bits architecture could be big or little endian.
# They are handled in the same way.
ifeq ($(SUBARCH),ppc64)
        error := $(error ppc64 big endian is not yet supported)
endif

#
# Architecture specific options.
ifeq ($(ARCH),arm)
        ARMV		:= $(shell echo $(SUBARCH) | sed -nr 's/armv([[:digit:]]).*/\1/p; t; i7')

        ifeq ($(ARMV),6)
                ARCHCFLAGS += -march=armv6
        endif

        ifeq ($(ARMV),7)
                ARCHCFLAGS += -march=armv7-a+fp
        endif

        ifeq ($(ARMV),8)
                # Running 'setarch linux32 uname -m' returns armv8l on travis aarch64.
                # This tells CRIU to handle armv8l just as armv7hf. Right now this is
                # only used for compile testing. No further verification of armv8l exists.
                ARCHCFLAGS += -march=armv7-a
                ARMV := 7
        endif

        DEFINES		:= -DCONFIG_ARMV$(ARMV) -DCONFIG_VDSO_32

        PROTOUFIX	:= y
	# For simplicity - compile code in Arm mode without interwork.
	# We could choose Thumb mode as default instead - but a dirty
	# experiment shows that with 90Kb PIEs Thumb code doesn't save
	# even one page. So, let's stick so far to Arm mode as it's more
	# universal around all different Arm variations, until someone
	# will find any use for Thumb mode. -dima
        CFLAGS_PIE	:= -marm
endif

ifeq ($(ARCH),aarch64)
        DEFINES		:= -DCONFIG_AARCH64
endif

ifeq ($(ARCH),ppc64)
        LDARCH		:= powerpc:common64
        DEFINES		:= -DCONFIG_PPC64 -D__SANE_USERSPACE_TYPES__
endif

ifeq ($(ARCH),x86)
        LDARCH		:= i386:x86-64
        DEFINES		:= -DCONFIG_X86_64
endif

ifeq ($(ARCH),mips)
        DEFINES		:= -DCONFIG_MIPS
endif

ifeq ($(ARCH),loongarch64)
        DEFINES		:= -DCONFIG_LOONGARCH64
endif

ifeq ($(ARCH),riscv64)
        DEFINES		:= -DCONFIG_RISCV64
endif

#
# CFLAGS_PIE:
#
# Ensure with -fno-optimize-sibling-calls that we don't create GOT
# (Global Offset Table) relocations with gcc compilers that don't have
# commit "S/390: Fix 64 bit sibcall".
ifeq ($(ARCH),s390)
        ARCH		:= s390
        DEFINES		:= -DCONFIG_S390
        CFLAGS_PIE	:= -fno-optimize-sibling-calls
endif

CFLAGS_PIE		+= -DCR_NOGLIBC
export CFLAGS_PIE

LDARCH ?= $(ARCH)
export LDARCH
export PROTOUFIX DEFINES

#
# Independent options for all tools.
DEFINES			+= -D_FILE_OFFSET_BITS=64
DEFINES			+= -D_LARGEFILE64_SOURCE
DEFINES			+= -D_GNU_SOURCE

WARNINGS		:= -Wall -Wformat-security -Wdeclaration-after-statement -Wstrict-prototypes

# -Wdangling-pointer results in false warning when we add a list element to
# local list head variable. It is false positive because before leaving the
# function we always check that local list head variable is empty, thus
# insuring that pointer to it is not dangling anywhere, but gcc can't
# understand it.
# Note: There is similar problem with kernel list, where this warning is also
# disabled: https://github.com/torvalds/linux/commit/49beadbd47c2
WARNINGS		+= -Wno-dangling-pointer -Wno-unknown-warning-option

CFLAGS-GCOV		:= --coverage -fno-exceptions -fno-inline -fprofile-update=atomic
export CFLAGS-GCOV

ifeq ($(ARCH),mips)
WARNINGS		:= -rdynamic
endif

ifeq ($(ARCH),loongarch64)
WARNINGS		+= -Wno-implicit-function-declaration
endif

ifneq ($(GCOV),)
        LDFLAGS         += -lgcov
        CFLAGS          += $(CFLAGS-GCOV)
endif

ifneq ($(NETWORK_LOCK_DEFAULT),)
	CFLAGS		+= -DNETWORK_LOCK_DEFAULT=$(NETWORK_LOCK_DEFAULT)
endif

ifeq ($(ASAN),1)
	CFLAGS-ASAN	:= -fsanitize=address
	export		CFLAGS-ASAN
	CFLAGS		+= $(CFLAGS-ASAN)
endif

ifneq ($(WERROR),0)
        WARNINGS	+= -Werror
endif

ifeq ($(DEBUG),1)
        DEFINES		+= -DCR_DEBUG
        CFLAGS		+= -O0 -ggdb3
else
        CFLAGS		+= -O2 -g
endif

ifeq ($(GMON),1)
        CFLAGS		+= -pg
        GMONLDOPT	+= -pg
export GMON GMONLDOPT
endif

AFLAGS			+= -D__ASSEMBLY__
CFLAGS			+= $(USERCFLAGS) $(ARCHCFLAGS) $(WARNINGS) $(DEFINES) -iquote include/
HOSTCFLAGS		+= $(WARNINGS) $(DEFINES) -iquote include/
export AFLAGS CFLAGS USERCLFAGS HOSTCFLAGS

# Default target
all: criu lib crit cuda_plugin
.PHONY: all

#
# Version headers.
include Makefile.versions

VERSION_HEADER		:= criu/include/version.h
GITID_FILE		:= .gitid
GITID		:= $(shell if [ -d ".git" ]; then git describe --always; fi)

# Git repository wasn't inited in CRIU folder
ifeq ($(GITID),)
        GITID := 0
else
        GITID_FILE_VALUE := $(shell if [ -f '$(GITID_FILE)' ]; then if [ `cat '$(GITID_FILE)'` = $(GITID) ]; then echo y; fi; fi)
        ifneq ($(GITID_FILE_VALUE),y)
                .PHONY: $(GITID_FILE)
        endif
endif

$(GITID_FILE):
	$(call msg-gen, $@)
	$(Q) echo "$(GITID)" > $(GITID_FILE)

$(VERSION_HEADER): Makefile.versions $(GITID_FILE)
	$(call msg-gen, $@)
	$(Q) echo "/* Autogenerated, do not edit */"			 	 > $@
	$(Q) echo "#ifndef __CR_VERSION_H__"					>> $@
	$(Q) echo "#define __CR_VERSION_H__"					>> $@
	$(Q) echo "#define CRIU_VERSION \"$(CRIU_VERSION)\""			>> $@
	$(Q) echo "#define CRIU_VERSION_MAJOR " $(CRIU_VERSION_MAJOR)		>> $@
	$(Q) echo "#define CRIU_VERSION_MINOR " $(CRIU_VERSION_MINOR)		>> $@
ifneq ($(CRIU_VERSION_SUBLEVEL),)
	$(Q) echo "#define CRIU_VERSION_SUBLEVEL " $(CRIU_VERSION_SUBLEVEL)	>> $@
endif
ifneq ($(CRIU_VERSION_EXTRA),)
	$(Q) echo "#define CRIU_VERSION_EXTRA " $(CRIU_VERSION_EXTRA)		>> $@
endif
	$(Q) echo "#define CRIU_GITID \"$(GITID)\""				>> $@
	$(Q) echo "#endif /* __CR_VERSION_H__ */"				>> $@

criu-deps	+= $(VERSION_HEADER)

#
# Setup proper link for asm headers in common code.
include/common/asm: include/common/arch/$(ARCH)/asm
	$(call msg-gen, $@)
	$(Q) ln -s ./arch/$(ARCH)/asm $@

criu-deps	+= include/common/asm

#
# Configure variables.
export CONFIG_HEADER := include/common/config.h
ifeq ($(filter tags etags cscope clean lint indent fetch-clang-format help mrproper,$(MAKECMDGOALS)),)
include Makefile.config
else
# To clean all files, enable make/build options here
export CONFIG_COMPAT := y
export CONFIG_GNUTLS := y
export CONFIG_HAS_LIBBPF := y
endif

#
# Protobuf images first, they are not depending
# on anything else.
$(eval $(call gen-built-in,images))
criu-deps	+= images/built-in.o

#
# Compel get used by CRIU, build it earlier
include Makefile.compel

#
# Next the socket CR library
#
SOCCR_A := soccr/libsoccr.a
soccr/Makefile: ;
soccr/%: $(CONFIG_HEADER) .FORCE
	$(Q) $(MAKE) $(build)=soccr $@
soccr/built-in.o: $(CONFIG_HEADER) .FORCE
	$(Q) $(MAKE) $(build)=soccr all
$(SOCCR_A): |soccr/built-in.o
criu-deps	+= $(SOCCR_A)

#
# LZ4 library
#
LZ4_OBJS = lz4/lib/liblz4.a criu/liblz4io.a
$(LZ4_OBJS) :
	git submodule init
	git submodule update
	$(Q) env -i PATH="$$PATH" make CC=$(CC) CFLAGS="$(CFLAGS)" -C lz4 lib lz4
	$(Q) $(AR) rcs criu/liblz4io.a lz4/programs/lz4io.o

criu-deps += $(LZ4_OBJS)
CFLAGS += -I.

#
# CRIU building done in own directory
# with slightly different rules so we
# can't use nmk engine directly (we
# build syscalls library and such).
#
# But note that we're already included
# the nmk so we can reuse it there.
criu/Makefile: ;
criu/Makefile.packages: ;
criu/Makefile.crtools: ;
criu/%: $(criu-deps) .FORCE
	$(Q) $(MAKE) $(build)=criu $@
criu: $(criu-deps)
	$(Q) $(MAKE) $(build)=criu all
.PHONY: criu

unittest: $(criu-deps)
	$(Q) $(MAKE) $(build)=criu unittest
.PHONY: unittest


#
# Libraries next once criu is ready
# (we might generate headers and such
# when building criu itself).
lib/Makefile: ;
lib/%: criu .FORCE
	$(Q) $(MAKE) $(build)=lib $@
lib: criu
	$(Q) $(MAKE) $(build)=lib all
.PHONY: lib

clean mrproper:
	$(Q) $(MAKE) $(build)=images $@
	$(Q) $(MAKE) $(build)=criu $@
	$(Q) $(MAKE) $(build)=soccr $@
	$(Q) $(MAKE) $(build)=lib $@
	$(Q) $(MAKE) $(build)=crit $@
	$(Q) $(MAKE) $(build)=compel $@
	$(Q) $(MAKE) $(build)=compel/plugins $@
	$(Q) $(MAKE) -C lz4 clean
	rm -rf $(LZ4_OBJS)
.PHONY: clean mrproper

clean-amdgpu_plugin:
	$(Q) $(MAKE) -C plugins/amdgpu clean
.PHONY: clean-amdgpu_plugin

clean-cuda_plugin:
	$(Q) $(MAKE) -C plugins/cuda clean
.PHONY: clean-cuda_plugin

clean-top:
	$(Q) $(MAKE) -C Documentation clean
	$(Q) $(MAKE) $(build)=test/compel clean
	$(Q) $(RM) .gitid
.PHONY: clean-top

clean: clean-top clean-amdgpu_plugin clean-cuda_plugin

mrproper-top: clean-top clean-amdgpu_plugin clean-cuda_plugin
	$(Q) $(RM) $(CONFIG_HEADER)
	$(Q) $(RM) $(VERSION_HEADER)
	$(Q) $(RM) $(COMPEL_VERSION_HEADER)
	$(Q) $(RM) include/common/asm
	$(Q) $(RM) compel/include/asm
	$(Q) $(RM) cscope.*
	$(Q) $(RM) tags TAGS
.PHONY: mrproper-top

mrproper: mrproper-top

#
# Non-CRIU stuff.
#

docs:
	$(Q) $(MAKE) -s -C Documentation all
.PHONY: docs

zdtm: all
	$(Q) $(MAKE) -C test/zdtm all
.PHONY: zdtm

test: zdtm
	$(Q) $(MAKE) -C test
.PHONY: test

amdgpu_plugin: criu
	$(Q) $(MAKE) -C plugins/amdgpu all
.PHONY: amdgpu_plugin

cuda_plugin: criu
	$(Q) $(MAKE) -C plugins/cuda all
.PHONY: cuda_plugin

crit: lib
	$(Q) $(MAKE) -C crit
.PHONY: crit

#
# Generating tar requires tag matched CRIU_VERSION.
# If not found then simply use GIT's describe with
# "v" prefix stripped.
head-name := $(shell git tag -l v$(CRIU_VERSION))
ifeq ($(head-name),)
        head-name := $(shell git describe 2>/dev/null)
endif
# If no git tag could describe current commit,
# use pre-defined CRIU_VERSION with GITID (if any).
ifeq ($(head-name),)
        ifneq ($(GITID),)
                head-name := $(CRIU_VERSION)-$(GITID)
        else
                head-name := $(CRIU_VERSION)
        endif
endif
tar-name := $(shell echo $(head-name) | sed -e 's/^v//g')
criu-$(tar-name).tar.bz2:
	git archive --format tar --prefix 'criu-$(tar-name)/' $(head-name) | bzip2 > $@
dist tar: criu-$(tar-name).tar.bz2 ;
.PHONY: dist tar

TAGS_FILES_REGEXP := . -name '*.[hcS]' ! -path './.*' \( ! -path './test/*' -o -path './test/zdtm/lib/*' \)
tags:
	$(call msg-gen, $@)
	$(Q) $(RM) tags
	$(Q) $(FIND) $(TAGS_FILES_REGEXP) -print | xargs $(CTAGS) -a
.PHONY: tags

etags:
	$(call msg-gen, $@)
	$(Q) $(RM) TAGS
	$(Q) $(FIND) $(TAGS_FILES_REGEXP) -print | xargs $(ETAGS) -a
.PHONY: etags


cscope:
	$(call msg-gen, $@)
	$(Q) $(FIND) $(TAGS_FILES_REGEXP) ! -type l -print > cscope.files
	$(Q) $(CSCOPE) -bkqu
.PHONY: cscope

gcov:
	$(E) " GCOV"
	$(Q) test -d gcov || mkdir gcov && \
	geninfo --output-filename gcov/criu.info --no-recursion criu/ && \
	cd gcov && \
	genhtml --rc lcov_branch_coverage=1 --output-directory html criu.info
	@echo "Code coverage report is in `pwd`/gcov/html/ directory."
.PHONY: gcov

docker-build:
	$(MAKE) -C scripts/build/ x86_64
.PHONY: docker-build

docker-test:
	docker run --rm --privileged -v /lib/modules:/lib/modules --network=host --cgroupns=host criu-x86_64 \
		./test/zdtm.py run -a --keep-going --ignore-taint
.PHONY: docker-test

help:
	@echo '    Targets:'
	@echo '      all             - Build all [*] targets'
	@echo '    * criu            - Build criu'
	@echo '    * crit            - Build crit'
	@echo '      zdtm            - Build zdtm test-suite'
	@echo '      docs            - Build documentation'
	@echo '      install         - Install CRIU (see INSTALL.md)'
	@echo '      uninstall       - Uninstall CRIU'
	@echo '      dist            - Create a source tarball'
	@echo '      clean           - Clean most, but leave enough to navigate'
	@echo '      mrproper        - Delete all compiled/generated files'
	@echo '      tags            - Generate tags file (ctags)'
	@echo '      etags           - Generate TAGS file (etags)'
	@echo '      cscope          - Generate cscope database'
	@echo '      test            - Run zdtm test-suite'

=== compel/Makefile ===
include Makefile.versions

COMPEL_SO_VERSION	:= $(COMPEL_SO_VERSION_MAJOR)$(if $(COMPEL_SO_VERSION_MINOR),.$(COMPEL_SO_VERSION_MINOR))$(if $(COMPEL_SO_VERSION_SUBLEVEL),.$(COMPEL_SO_VERSION_SUBLEVEL))
COMPEL_SO_VERSION_CODE	:= $(shell expr $(COMPEL_SO_VERSION_MAJOR) \* 65536 \+ $(COMPEL_SO_VERSION_MINOR) \* 256 \+ $(COMPEL_SO_VERSION_SUBLEVEL))
ccflags-y		+= -DINCLUDEDIR=\"$(INCLUDEDIR)\"
ccflags-y		+= -DLIBEXECDIR=\"$(LIBEXECDIR)\"
ccflags-y		+= -DLIBDIR=\"$(LIBDIR)\"
ccflags-y		+= -DSTATIC_LIB=\"$(LIBCOMPEL_A)\"
ccflags-y		+= -DDYN_LIB=\"$(LIBCOMPEL_SO).$(COMPEL_SO_VERSION_MAJOR)\"
ccflags-y		+= -iquote compel/arch/$(ARCH)/src/lib/include
ccflags-y		+= -iquote compel/include
ccflags-y		+= -fno-strict-aliasing
ccflags-y		+= -fPIC
ldflags-y		+= -r

#
# UAPI inclusion, referred as <compel/...>
ccflags-y		+= -I compel/include/uapi

lib-name		:= $(LIBCOMPEL_A)
lib-y			+= src/lib/log.o
host-lib-y		+= src/lib/log.o

lib-y			+= arch/$(ARCH)/src/lib/cpu.o
lib-y			+= arch/$(ARCH)/src/lib/infect.o
lib-y			+= src/lib/infect-rpc.o
lib-y			+= src/lib/infect-util.o
lib-y			+= src/lib/infect.o
lib-y			+= src/lib/ptrace.o

ifeq ($(ARCH),x86)
lib-y			+= arch/$(ARCH)/src/lib/thread_area.o
endif

# handle_elf() has no support of ELF relocations on ARM and RISCV64 (yet?)
ifneq ($(filter arm aarch64 loongarch64 riscv64,$(ARCH)),)
CFLAGS			+= -DNO_RELOCS
HOSTCFLAGS		+= -DNO_RELOCS
endif

obj-y			+= src/main.o
obj-y			+= arch/$(ARCH)/src/lib/handle-elf.o
obj-y			+= src/lib/handle-elf.o

host-ccflags-y		+= $(ccflags-y)

hostprogs-y		+= compel-host-bin
compel-host-bin-objs	:= $(patsubst %.o,%-host.o,$(obj-y) $(host-lib-y))

cleanup-y		+= compel/compel
cleanup-y		+= compel/compel-host-bin
cleanup-y		+= compel/libcompel.so

install: compel/compel compel/$(LIBCOMPEL_SO) compel/$(LIBCOMPEL_A)
	$(E) "  INSTALL " compel
	$(Q) mkdir -p $(DESTDIR)$(BINDIR)
	$(Q) install -m 755 compel/compel $(DESTDIR)$(BINDIR)/crac-compel
	$(E) "  INSTALL " $(LIBCOMPEL_SO)
	$(Q) mkdir -p $(DESTDIR)$(LIBDIR)
	$(Q) install -m 0644 compel/$(LIBCOMPEL_SO) $(DESTDIR)$(LIBDIR)
	$(Q) install -m 755 compel/$(LIBCOMPEL_SO) $(DESTDIR)$(LIBDIR)/$(LIBCOMPEL_SO).$(COMPEL_SO_VERSION_MAJOR).$(COMPEL_SO_VERSION_MINOR)
	$(Q) ln -fns $(LIBCOMPEL_SO).$(COMPEL_SO_VERSION_MAJOR).$(COMPEL_SO_VERSION_MINOR) $(DESTDIR)$(LIBDIR)/$(LIBCOMPEL_SO).$(COMPEL_SO_VERSION_MAJOR)
	$(Q) ln -fns $(LIBCOMPEL_SO).$(COMPEL_SO_VERSION_MAJOR).$(COMPEL_SO_VERSION_MINOR) $(DESTDIR)$(LIBDIR)/$(LIBCOMPEL_SO)
	$(E) "  INSTALL " $(LIBCOMPEL_A)
	$(Q) install -m 0644 compel/$(LIBCOMPEL_A) $(DESTDIR)$(LIBDIR)
	$(E) "  INSTALL " compel uapi
	$(Q) mkdir -p $(DESTDIR)$(INCLUDEDIR)/crac-criu/compel/asm
	$(Q) cp compel/include/uapi/*.h $(DESTDIR)$(INCLUDEDIR)/crac-criu/compel/
	$(Q) cp compel/include/uapi/asm/*.h $(DESTDIR)$(INCLUDEDIR)/crac-criu/compel/asm/
	$(Q) mkdir -p $(DESTDIR)$(INCLUDEDIR)/crac-criu/compel/common/asm
	$(Q) cp include/common/compiler.h $(DESTDIR)$(INCLUDEDIR)/crac-criu/compel/common/
.PHONY: install

uninstall:
	$(E) " UNINSTALL" compel
	$(Q) $(RM) $(addprefix $(DESTDIR)$(BINDIR)/,crac-compel)
	$(E) " UNINSTALL" $(LIBCOMPEL_SO)
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBDIR)/,$(LIBCOMPEL_SO))
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBDIR)/,$(LIBCOMPEL_SO).$(COMPEL_SO_VERSION_MAJOR))
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBDIR)/,$(LIBCOMPEL_SO).$(COMPEL_SO_VERSION_MAJOR).$(COMPEL_SO_VERSION_MINOR))
	$(E) " UNINSTALL" $(LIBCOMPEL_A)
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBDIR)/,$(LIBCOMPEL_A))
	$(E) " UNINSTALL" compel uapi
	$(Q) $(RM) -rf $(addprefix $(DESTDIR)$(INCLUDEDIR)/,crac-criu/compel/*)
.PHONY: uninstall

=== criu/Makefile ===
# here is a workaround for a bug in libnl-3:
# 6a8d90f5fec4 "attr: Allow attribute type 0"
WRAPFLAGS		+= -Wl,--wrap=nla_parse,--wrap=nlmsg_parse

ARCH_DIR		:= criu/arch/$(ARCH)
PIE_DIR			:= criu/pie
export ARCH_DIR PIE_DIR

ifeq ($(filter clean mrproper,$(MAKECMDGOALS)),)
        CFLAGS		+= $(shell $(COMPEL_BIN) includes)
        COMPEL_LIBS	:= $(shell $(COMPEL_BIN) --static libs)
        CFLAGS_PIE	+= $(shell $(COMPEL_BIN) cflags)
endif

#
# Configuration file paths
CONFIG-DEFINES		+= -DSYSCONFDIR='"/etc"'
CONFIG-DEFINES		+= -DGLOBAL_CONFIG_DIR='"/etc/criu/"'
CONFIG-DEFINES		+= -DDEFAULT_CONFIG_FILENAME='"default.conf"'
CONFIG-DEFINES		+= -DUSER_CONFIG_DIR='".criu/"'

#
# General flags.
CFLAGS			+= -fno-strict-aliasing
CFLAGS			+= -iquote criu/include
CFLAGS			+= -iquote include
CFLAGS			+= -iquote images
CFLAGS			+= -iquote $(ARCH_DIR)/include
CFLAGS			+= -iquote .
CFLAGS			+= $(shell $(PKG_CONFIG) --cflags --static libnl-3.0)
CFLAGS			+= $(CONFIG-DEFINES)

ifeq ($(GMON),1)
	CFLAGS		+= -pg
	GMONLDOPT	:= -pg
endif

# msg-* printing
include $(__nmk_dir)msg.mk

#
# Needed libraries checks
include criu/Makefile.packages

#
# Architecture dependent part.
ARCH-LIB		:= $(ARCH_DIR)/crtools.built-in.o
$(ARCH-LIB): .FORCE
	$(Q) $(MAKE) $(build)=$(ARCH_DIR) all

#
# PIE library code.
criu/pie/pie.lib.a: $(ARCH-LIB) .FORCE
	$(Q) $(MAKE) $(call build-as,Makefile.library,criu/pie) all

#
# PIE code blobs themseves.
pie: criu/pie/pie.lib.a
	$(Q) $(MAKE) $(build)=criu/pie all
.PHONY: pie

criu/pie/Makefile: ;
criu/pie/Makefile.library: ;
criu/pie/%: pie ;

#
# CRIU executable
PROGRAM-BUILTINS	+= criu/pie/pie.lib.a
PROGRAM-BUILTINS	+= images/built-in.o
PROGRAM-BUILTINS	+= $(obj)/built-in.o
PROGRAM-BUILTINS	+= $(ARCH-LIB)
PROGRAM-BUILTINS	+= soccr/libsoccr.a
PROGRAM-BUILTINS	+= $(COMPEL_LIBS)

$(obj)/built-in.o: pie
	$(Q) $(MAKE) $(call build-as,Makefile.crtools,criu) all


$(obj)/Makefile: ;
$(obj)/Makefile.crtools: ;
$(obj)/Makefile.packages: ;

$(obj)/%: pie
	$(Q) $(MAKE) $(call build-as,Makefile.crtools,criu) $@

$(obj)/criu: $(PROGRAM-BUILTINS)
	$(call msg-link, $@)
	$(Q) $(CC) $(CFLAGS) $^ $(LDFLAGS) $(LIBS) $(WRAPFLAGS) $(GMONLDOPT) -rdynamic -o $@

UNIT-BUILTINS		+= $(obj)/util.o
UNIT-BUILTINS		+= $(obj)/config.o
UNIT-BUILTINS		+= $(obj)/log.o
UNIT-BUILTINS		+= $(obj)/string.o
UNIT-BUILTINS		+= $(obj)/unittest/built-in.o

$(obj)/unittest/Makefile: ;

$(obj)/unittest/%: .FORCE

$(obj)/unittest/built-in.o: .FORCE
	$(Q) $(MAKE) $(call build-as,Makefile,criu/unittest) all

$(obj)/unittest/unittest: $(UNIT-BUILTINS)
	$(call msg-link, $@)
	$(Q) $(CC) $(CFLAGS) $^ $(LDFLAGS) $(LIBS) $(WRAPFLAGS) -rdynamic -o $@

unittest: $(obj)/unittest/unittest
	$(Q) $(obj)/unittest/$@

.PHONY: unittest

#
# Clean the most, except generated c files
subclean:
	$(Q) $(RM) $(obj)/*.{gcda,gcno,gcov}
	$(Q) $(RM) $(obj)/pie/*.{gcda,gcno,gcov}
	$(Q) $(RM) -r $(obj)/gcov
	$(Q) $(MAKE) $(build)=$(ARCH_DIR) clean
	$(Q) $(MAKE) $(call build-as,Makefile.library,$(PIE_DIR)) clean
	$(Q) $(MAKE) $(call build-as,Makefile.crtools,criu) clean
	$(Q) $(MAKE) $(call build-as,Makefile,criu/unittest) clean
	$(Q) $(MAKE) $(build)=$(PIE_DIR) clean
.PHONY: subclean
cleanup-y      += $(obj)/criu
clean: subclean

#
# Delete all generated files
subproper:
	$(Q) $(MAKE) $(build)=$(ARCH_DIR) mrproper
	$(Q) $(MAKE) $(call build-as,Makefile.library,$(PIE_DIR)) mrproper
	$(Q) $(MAKE) $(call build-as,Makefile.crtools,criu) mrproper
	$(Q) $(MAKE) $(build)=$(PIE_DIR) mrproper
.PHONY: subproper
mrproper: subproper

UAPI_HEADERS := criu/include/criu-plugin.h
UAPI_HEADERS += criu/include/criu-log.h

install: $(obj)/criu
	$(E) "  INSTALL " $(obj)/criu
	$(Q) mkdir -p $(DESTDIR)$(SBINDIR)
	$(Q) install -m 755 $(obj)/criu $(DESTDIR)$(SBINDIR)/crac-criu
	$(Q) mkdir -p $(DESTDIR)$(INCLUDEDIR)/crac-criu/criu/
	$(Q) install -m 644 $(UAPI_HEADERS) $(DESTDIR)$(INCLUDEDIR)/crac-criu/criu/
	$(Q) mkdir -p $(DESTDIR)$(LIBEXECDIR)/criu/scripts
	$(Q) install -m 755 scripts/systemd-autofs-restart.sh $(DESTDIR)$(LIBEXECDIR)/criu/scripts
	$(E) "  INSTALL " scripts/criu-ns
	$(Q) install -m 755 scripts/criu-ns $(DESTDIR)$(SBINDIR)/crac-criu-ns
.PHONY: install

uninstall:
	$(E) " UNINSTALL" criu
	$(Q) $(RM) $(addprefix $(DESTDIR)$(SBINDIR)/,crac-criu)
	$(Q) $(RM) $(addprefix $(DESTDIR)$(SBINDIR)/,crac-criu-ns)
	$(Q) $(RM) $(addprefix $(DESTDIR)$(INCLUDEDIR)/crac-criu/criu/,$(notdir $(UAPI_HEADERS)))
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBEXECDIR)/criu/scripts/,systemd-autofs-restart.sh)
.PHONY: uninstall

all-y += check-packages $(obj)/criu

=== lib/Makefile ===
CRIU_SO			:= libcrac-criu.so
CRIU_A			:= libcrac-criu.a
UAPI_HEADERS		:= lib/c/criu.h images/rpc.proto images/rpc.pb-c.h criu/include/version.h

all-y	+= lib-c lib-a lib-py

#
# C language bindings.
lib/c/Makefile: ;
lib/c/%: .FORCE
	$(Q) $(MAKE) $(build)=lib/c $@

cflags-so		+= $(CFLAGS) -rdynamic -Wl,-soname,$(CRIU_SO).$(CRIU_SO_VERSION_MAJOR)
ldflags-so		+= -Bstatic -lprotobuf-c -Bdynamic

lib/c/$(CRIU_SO): lib/c/built-in.o
	$(call msg-link, $@)
	$(Q) $(CC) -shared $(cflags-so) -o $@ $^ $(ldflags-so) $(LDFLAGS)
lib/c/$(CRIU_A): lib/c/built-in.o
	$(call msg-link, $@)
	$(Q) $(AR) rcs $@ $^
lib-c: lib/c/$(CRIU_SO)
lib-a: lib/c/$(CRIU_A)
.PHONY: lib-c lib-a

#
# Python bindings.
lib/pycriu/Makefile: ;
lib/pycriu/%: .FORCE
	$(call msg-gen, $@)
	$(Q) $(MAKE) $(build)=lib/pycriu $@
lib-py:
	$(Q) $(MAKE) $(build)=lib/pycriu all
.PHONY: lib-py

clean-lib:
	$(Q) $(MAKE) $(build)=lib/c clean
	$(Q) $(MAKE) $(build)=lib/pycriu clean
.PHONY: clean-lib
clean: clean-lib
cleanup-y	+= lib/c/$(CRIU_SO) lib/c/$(CRIU_A) lib/c/criu.pc
mrproper: clean

install: lib-c lib-a lib-py lib/c/criu.pc.in
	$(E) "  INSTALL " lib
	$(Q) mkdir -p $(DESTDIR)$(LIBDIR)
	$(Q) install -m 755 lib/c/$(CRIU_SO) $(DESTDIR)$(LIBDIR)/$(CRIU_SO).$(CRIU_SO_VERSION_MAJOR).$(CRIU_SO_VERSION_MINOR)
	$(Q) ln -fns $(CRIU_SO).$(CRIU_SO_VERSION_MAJOR).$(CRIU_SO_VERSION_MINOR) $(DESTDIR)$(LIBDIR)/$(CRIU_SO).$(CRIU_SO_VERSION_MAJOR)
	$(Q) ln -fns $(CRIU_SO).$(CRIU_SO_VERSION_MAJOR).$(CRIU_SO_VERSION_MINOR) $(DESTDIR)$(LIBDIR)/$(CRIU_SO)
	$(Q) install -m 755 lib/c/$(CRIU_A) $(DESTDIR)$(LIBDIR)/$(CRIU_A)
	$(Q) mkdir -p $(DESTDIR)$(INCLUDEDIR)/crac-criu/criu/
	$(Q) install -m 644 $(UAPI_HEADERS) $(DESTDIR)$(INCLUDEDIR)/crac-criu/criu/
	$(E) "  INSTALL " pkgconfig/criu.pc
	$(Q) mkdir -p $(DESTDIR)$(LIBDIR)/pkgconfig
	$(Q) sed -e 's,@version@,$(CRIU_VERSION),' -e 's,@libdir@,$(LIBDIR),' -e 's,@includedir@,$(dir $(INCLUDEDIR)/crac-criu/criu/),' lib/c/criu.pc.in > lib/c/criu.pc
	$(Q) install -m 644 lib/c/criu.pc $(DESTDIR)$(LIBDIR)/pkgconfig/crac-criu.pc
ifeq ($(SKIP_PIP_INSTALL),0)
	$(E) "  INSTALL " pycriu
	$(Q) $(PYTHON) -m pip install $(PIPFLAGS) --prefix=$(DESTDIR)$(PREFIX) ./lib
else
	$(E) " SKIP INSTALL pycriu"
endif
.PHONY: install

uninstall:
	$(E) " UNINSTALL" $(CRIU_SO)
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBDIR)/,$(CRIU_SO).$(CRIU_SO_VERSION_MAJOR))
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBDIR)/,$(CRIU_SO))
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBDIR)/,$(CRIU_A))
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBDIR)/,$(CRIU_SO).$(CRIU_SO_VERSION_MAJOR).$(CRIU_SO_VERSION_MINOR))
	$(Q) $(RM) $(addprefix $(DESTDIR)$(INCLUDEDIR)/crac-criu/criu/,$(notdir $(UAPI_HEADERS)))
	$(E) " UNINSTALL" pkgconfig/crac-criu.pc
	$(Q) $(RM) $(addprefix $(DESTDIR)$(LIBDIR)/pkgconfig/,crac-criu.pc)
ifeq ($(SKIP_PIP_INSTALL),0)
	$(E) " UNINSTALL" pycriu
	$(Q) $(PYTHON) ./scripts/uninstall_module.py --prefix=$(DESTDIR)$(PREFIX) pycriu
else
	$(E) " SKIP UNINSTALL pycriu"
endif
.PHONY: uninstall

=== scripts/build/Makefile ===
ARCHES := x86_64 fedora-asan fedora-rawhide armv7hf centos8
STABLE_CROSS_ARCHES := armv7-stable-cross aarch64-stable-cross ppc64-stable-cross mips64el-stable-cross riscv64-stable-cross
UNSTABLE_CROSS_ARCHES := armv7-unstable-cross aarch64-unstable-cross ppc64-unstable-cross mips64el-unstable-cross
NON_CLANG := $(UNSTABLE_CROSS_ARCHES) $(STABLE_CROSS_ARCHES)
CREATE_DOCKERFILES := $(ARCHES) $(NON_CLANG)
TARGETS := $(ARCHES) alpine archlinux
TARGETS_CLANG := $(addsuffix $(TARGETS),-clang)
CONTAINER_RUNTIME := docker
CONTAINER_TARGETS := $(TARGETS) $(NON_CLANG)

all: $(CONTAINER_TARGETS) $(TARGETS_CLANG)
.PHONY: all

# A build for each architecture requires appropriate Dockerfile
define FILE_DEP
$(1): Dockerfile.$(1)
endef
$(foreach file,$(CREATE_DOCKERFILES),$(eval $(call FILE_DEP,$(file))))

Dockerfile.%: Dockerfile.%.hdr Dockerfile.%.tmpl
	cat $^ > $@

$(CONTAINER_TARGETS):
	$(CONTAINER_RUNTIME) build $(BUILD_OPTIONS) -t criu-$@ -f Dockerfile.$@ $(DB_CC) ../..
.PHONY: $(CONTAINER_TARGETS)

# Clang builds add some Docker build env
define CLANG_DEP
$(1)-clang: $(1)
endef
$(foreach t,$(TARGETS),$(eval $(call CLANG_DEP,$(t))))

%-clang:	DB_CC=--build-arg CC=clang
s390x-clang:	DB_CC=--build-arg CC=clang-3.8
.PHONY: $(TARGETS_CLANG)

=== scripts/ci/Makefile ===
local:
	./run-ci-tests.sh
.PHONY: local

after_success:
	./ci-after-success.sh
.PHONY: after_success

target-suffix =
ifdef CLANG
	target-suffix = -clang
endif

TARGETS := alpine fedora-rawhide centos8 archlinux
ZDTM_OPTS :=
UNAME := $(shell uname -m)
export UNAME
CONTAINER_RUNTIME := docker
export CONTAINER_RUNTIME

alpine: ZDTM_OPTS=-x zdtm/static/binfmt_misc -x zdtm/static/sched_policy00

ifeq ($(GITHUB_ACTIONS),true)
	# GitHub Actions does not give us a real TTY and errors out with
	# 'the input device is not a TTY' if using '-t'
	CONTAINER_TERMINAL := -i
else
	CONTAINER_TERMINAL := -it
endif

export CONTAINER_TERMINAL

ifeq ($(UNAME),x86_64)
	# On anything besides x86_64 Travis is running unprivileged LXD
	# containers which do not support running docker with '--privileged'.
	CONTAINER_OPTS := --rm $(CONTAINER_TERMINAL) --privileged --userns=host --cgroupns=host -v /lib/modules:/lib/modules --tmpfs /run
else
	CONTAINER_OPTS := --rm -v /lib/modules:/lib/modules --tmpfs /run
endif

ifeq ($(CONTAINER_RUNTIME),podman)
	# Podman limits the number of processes in a container using cgroups.
	# Disable it as it breaks the thread-bomb test
	CONTAINER_OPTS += --pids-limit=0
endif

export ZDTM_OPTS

$(TARGETS):
	$(MAKE) -C ../build $@$(target-suffix)
	$(CONTAINER_RUNTIME) run --env-file docker.env -v `pwd`/../../:/criu $(if $(ZDTM_OPTS),-e ZDTM_OPTS) $(CONTAINER_OPTS) criu-$@ scripts/ci/run-ci-tests.sh

fedora-asan:
	$(MAKE) -C ../build $@$(target-suffix)
	$(CONTAINER_RUNTIME) run $(CONTAINER_OPTS) -v `pwd`/../../:/criu criu-$@ ./scripts/ci/asan.sh $(ZDTM_OPTS)

docker-test:
	./docker-test.sh

podman-test:
	./podman-test.sh

java-test:
	./java-test.sh

java-it:
	./java-it.sh

setup-vagrant:
	./vagrant.sh setup

vagrant-fedora-no-vdso: setup-vagrant
	./vagrant.sh fedora-no-vdso

vagrant-fedora-rawhide: setup-vagrant
	./vagrant.sh fedora-rawhide

vagrant-fedora-non-root: setup-vagrant
	./vagrant.sh fedora-non-root

.PHONY: setup-vagrant vagrant-fedora-no-vdso vagrant-fedora-rawhide vagrant-fedora-non-root

check-commit:
	($(MAKE) -j $$(nproc) -C ../.. && \
		echo "Commit $$(git rev-parse --short HEAD) built successfully") || \
		(echo "Build failed for $$(git rev-list -n 1 --pretty HEAD)" && \
		exit 1)

.PHONY: check-commit

loongarch64-qemu-test:
	./loongarch64-qemu-test.sh

.PHONY: loongarch64-qemu-test

%:
	$(MAKE) -C ../build $@$(target-suffix)

=== test/compel/Makefile ===
# Relative path to original objects
define compel_obj_path
        $(addprefix ../../compel/,$(1))
endef

host-ccflags-y		+= -iquote test/compel/arch/$(ARCH)/include
test_objs		:= $(filter-out main.o,$(compel-objs))

hostprogs-y		+= handle_binary
handle_binary-objs	+= $(call compel_obj_path,$(test_objs))
handle_binary-objs	+= main.o
handle_binary-objs	+= handle_binary.o

ifeq ($(ARCH),x86)
    handle_binary-objs	+= handle_binary_32.o
    HOSTCFLAGS_handle_binary.o		+= -DCONFIG_X86_64
    HOSTCFLAGS_handle_binary_32.o	+= -DCONFIG_X86_32
endif

=== test/zdtm/Makefile ===
SUBDIRS	:=	lib static transition

all: $(SUBDIRS)
.PHONY: all $(SUBDIRS)

$(SUBDIRS):
	$(MAKE) -C $@ all

static: lib
transition: lib

%:
	set -e; for d in $(SUBDIRS); do $(MAKE) -C $$d $@; done

=== criu/arch/loongarch64/Makefile ===
builtin-name		:= crtools.built-in.o

ccflags-y		+= -iquote $(obj)/include
ccflags-y		+= -iquote criu/include -iquote include
ccflags-y		+= $(COMPEL_UAPI_INCLUDES)

asflags-y		+= -Wstrict-prototypes
asflags-y		+= -D__ASSEMBLY__ -nostdlib -fomit-frame-pointer
asflags-y		+= -iquote $(obj)/include
ldflags-y		+= -r -z noexecstack

obj-y			+= cpu.o
obj-y			+= crtools.o
obj-y			+= sigframe.o

=== lib/dll/example/Makefile ===
# ##########################################################################
# LZ4 programs - Makefile
# Copyright (C) Yann Collet 2016-2020
#
# GPL v2 License
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# You can contact the author at :
#  - LZ4 homepage : http://www.lz4.org
#  - LZ4 source repository : https://github.com/lz4/lz4
# ##########################################################################

VOID    := /dev/null
LZ4DIR  := ../include
LIBDIR  := ../static
DLLDIR  := ../dll

CFLAGS  ?= -O3   # can select custom flags. For example : CFLAGS="-O2 -g" make
CFLAGS  += -Wall -Wextra -Wundef -Wcast-qual -Wcast-align -Wshadow -Wswitch-enum \
           -Wdeclaration-after-statement -Wstrict-prototypes \
           -Wpointer-arith -Wstrict-aliasing=1
CFLAGS  += $(MOREFLAGS)
CPPFLAGS:= -I$(LZ4DIR) -DXXH_NAMESPACE=LZ4_
FLAGS   := $(CFLAGS) $(CPPFLAGS) $(LDFLAGS)


# Define *.exe as extension for Windows systems
ifneq (,$(filter Windows%,$(OS)))
EXT =.exe
else
EXT =
endif

.PHONY: default fullbench-dll fullbench-lib


default: all

all: fullbench-dll fullbench-lib


fullbench-lib: fullbench.c xxhash.c
	$(CC) $(FLAGS) $^ -o $@$(EXT) $(LIBDIR)/liblz4_static.lib

fullbench-dll: fullbench.c xxhash.c
	$(CC) $(FLAGS) $^ -o $@$(EXT) -DLZ4_DLL_IMPORT=1 $(DLLDIR)/liblz4.dll

clean:
	@$(RM) fullbench-dll$(EXT) fullbench-lib$(EXT) \
	@echo Cleaning completed

=== test/others/ns_ext/Makefile ===
run: run_pidns run_net run_pid

run_net:
	./run.sh net

run_pid:
	./run.sh pid

run_pidns:
	unshare -fp -m --mount-proc --propagation private ./run_pidns.sh

clean:
	rm -rf images output  pidfile  pidfile2  pidfile3
.PHONY: clean run

=== test/others/rpc/Makefile ===
all: test-c rpc_pb2.py criu
.PHONY: all

CFLAGS += -g -Werror -Wall -I.
LDLIBS +=  -lprotobuf-c

PYTHON ?= python3

run: all
	@make -C .. loop
	mkdir -p build/{imgs_errno,imgs_ps,imgs_c,imgs_loop,imgs_py}
	chmod a+rwx build
	chmod a+rwx build/{imgs_errno,imgs_ps,imgs_c,imgs_loop,imgs_py}
	rm -f build/status
	@# Create all log files to be accessible for anybody
	@# so that they can be displayed by any user.
	for i in imgs_errno/criu.log imgs_ps/page-server.log imgs_ps/dump.log \
		imgs_c/restore-c.log imgs_loop/criu.log imgs_loop/dump-loop.log \
		imgs_py/criu.log imgs_py/restore-py.log imgs_c/criu.log service.log; do \
		touch build/$$i; chmod 666 build/$$i; \
	done
	sudo -g '#1000' -u '#1000' mkfifo build/status
	@# Need to start the criu daemon here to access the pidfile.
	@# The script read.py is used to wait until 'criu service'
	@# is ready. As 'read -n 1' in some releases has a bug and does
	@# not read correctly a \0, using python is a workaround.
	sudo -g '#1000' -u '#1000' -- bash -c "exec 200<>build/status; \
		./criu service -v4 -W build --address criu_service.socket \
		-d --pidfile pidfile -o service.log --status-fd 200; \
		$(PYTHON) read.py build/status"
	rm -f build/status
	chmod a+rw build/pidfile
	sudo -g '#1000' -u '#1000' ./run.sh
	sudo -g '#1000' -u '#1000' ./version.py
	# run the configuration file via RPC test cases
	./config_file.py build

criu: ../../../criu/criu
	cp ../../../criu/criu $@
	chmod u+s $@

test-c: rpc.pb-c.o test-c.o

test-c.o: test-c.c rpc.pb-c.c

rpc_pb2.py: rpc.proto
	protoc --proto_path=. --python_out=. rpc.proto

rpc.pb-c.c: rpc.proto
	protoc-c --proto_path=. --c_out=. rpc.proto

clean:
	rm -rf build rpc.pb-c.o test-c.o test-c rpc.pb-c.c rpc.pb-c.h rpc_pb2.py rpc_pb2.pyc criu
.PHONY: clean

=== debian/changelog ===
crac-criu (4.1.1-0ubuntu1) questing; urgency=medium

  * New upstream release 4.1.1 based on criu 4.1.1
  * d/p/run-javaTests-as-dep8-tests.patch: modify
    upstream Java tests to be run without maven/internet.
  * d/tests: run upstream tests as autopkgtests

 -- Pushkar Kulkarni <pushkar.kulkarni@canonical.com>  Tue, 05 Aug 2025 20:59:09 +0530

=== debian/control ===
Source: crac-criu
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Pushkar Kulkarni <pushkar.kulkarni@canonical.com>
Build-Depends:
 debhelper-compat (= 13),
 libbsd-dev,
 libcap-dev,
 libgnutls28-dev,
 libnet1-dev,
 libnftables-dev,
 libnl-3-dev,
 libprotobuf-c-dev,
 libprotobuf-dev,
 pkgconf,
 protobuf-c-compiler,
 protobuf-compiler,
 uuid-dev,
Standards-Version: 4.7.0
Homepage: https://openjdk.org/projects/crac/
Vcs-Browser: https://github.com/canonical/crac-criu
Vcs-Git: https://github.com/canonical/crac-criu.git
Rules-Requires-Root: no

Package: crac-criu
Architecture: amd64
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: iproute2, python3
Description: Derivative of checkpoint restore in userspace (criu)
 adapted for openjdk/crac. It contains utilities to checkpoint
 and restore processes in userspace.
 .
 This package contains crac-criu binaries.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

export PREFIX="/usr"
export LIBEXECDIR="/usr/lib/crac-criu"

%:
	dh ${@}

override_dh_auto_test:
	# disabled: doesn't work yet, upstream criu tests fail to build on oracular

=== debian/tests/control ===
Tests: upstream-java-tests
Depends: openjdk-17-jdk-headless, testng, @
Restrictions: needs-root, allow-stderr

Tests: extra-java-it-tests
Depends: @, openjdk-17-jdk-headless
Restrictions: needs-root

=== debian/watch ===
version=4
opts="pgpmode=default,\
pgpsigurlmangle=s/archive\/refs\/tags/releases\/download/;s/([^\/]+)\.tar\.gz/$1\/@PACKAGE@-$1\.tar\.gz.asc/,\
uversionmangle=s/-rc/~rc/,\
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/canonical/crac-criu/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

opts=\
component=lz4,\
repack \
https://github.com/lz4/lz4/tags \
(?:.*?/)?v(1.9.4)\.tar\.gz 1.9.4
